<script lang="ts">
  import NewsCard from '$lib/components/cards/NewsCard.svelte';
  import Section from '$lib/components/sections/Section.svelte';
  import BaseLayout from '$lib/components/layouts/BaseLayout.svelte';
  import type { PageData } from './$types';
  import { axiosInstance } from '$lib/config';
  import Pagination from '$lib/components/Pagination.svelte';

  export let data: PageData;

  let news = data?.news.data,
    page = data.page || 1,
    pages = data?.news.pages;

  $: {
    news = data?.news.data;
    page = data.page || 1;
    pages = data?.news.pages;
  }

  async function handleSearch(event: any) {
    const res = await axiosInstance.get('/news', { params: { ...(event.detail && { name: event.detail }) } });

    if (event.detail) {
      pages = 0;
    } else {
      pages = data?.news.pages;
    }

    news = res.data.data;
  }
</script>

<svelte:head>
    <title>Новости</title>
</svelte:head>

<BaseLayout>
    <Section title="Новости" class="mt-16" {handleSearch}>
        <section class="grid 2xl:grid-cols-3 xl:grid-cols-2 gap-8">
            {#each news as { id, name: title, anons, createdAt: date, user: author, tagNews: tags, attachment }}
                <NewsCard
                    {id}
                    {title}
                    {anons}
                    {date}
                    {tags}
                    {author}
                    {attachment}
                />
            {/each}
        </section>
        <Pagination {page} {pages}/>
    </Section>
</BaseLayout>